# -*- coding:utf8 -*- #
# -----------------------------------------------------------------------------------
# ProjectName:   LightEditProject 
# FileName:     db 
# Author:       
# Datetime:    2023/8/7 18:55 
# Description： 
# 命名规范：文件名全小写+下划线，类名大驼峰，方法和变量小写+下划线连接， 
# 变量用名词，方法用动词 
# -----------------------------------------------------------------------------------
import pymysql
from ApiAuotTest.common.read_ini import ReadIni


class DB:
    def __init__(self):
        read_ini = ReadIni()
        self.conn = pymysql.connect(
            host=read_ini.get_sql_connect_message("host"),
            port=int(read_ini.get_sql_connect_message("port")),
            user=read_ini.get_sql_connect_message("user"),
            password=read_ini.get_sql_connect_message("pwd"),
            database=read_ini.get_sql_connect_message("database"),
            charset="utf8")
        self.cursor = self.conn.cursor()

    def close(self):
        self.cursor.close()
        self.conn.close()

    def delete(self, sql_sentence):
        self.cursor.execute(sql_sentence)
        self.conn.commit()

    def select(self, sql_sentence):
        self.cursor.execute(sql_sentence)
        result = self.cursor.fetchall()
        if result:
            return result[0][0]