# -*- coding:utf8 -*- #
# -----------------------------------------------------------------------------------
# ProjectName:   LightEditProject 
# FileName:     test_bpm 
# Author:       
# Datetime:    2023/8/7 22:48 
# Description： 
# 命名规范：文件名全小写+下划线，类名大驼峰，方法和变量小写+下划线连接， 
# 变量用名词，方法用动词 
# -----------------------------------------------------------------------------------
import logging
import allure
import pytest
from ApiAuotTest.common.read_excel import ReadExcel


class TestBPM:

    @allure.epic("BPM系统")
    @pytest.mark.parametrize("module, interface, title, level, method, url, mime, data, expect, sql_type, sql_sentence, update_key", ReadExcel().get_data())
    def test_bpm(self, req_fix, db_fix, module, interface, title, level, method, url, mime, data, expect, sql_type, sql_sentence, update_key):
        allure.dynamic.feature(module)
        allure.dynamic.story(interface)
        allure.dynamic.title(title)
        allure.dynamic.severity(level)
        if sql_type == "delete":
            db_fix.delete(sql_sentence)

        elif sql_type == "select":
            select_result = db_fix.select(sql_sentence)
            data[update_key] = select_result

        elif sql_type == "delete|select" or sql_type == "select|delete":
            db_fix.delete(sql_sentence["delete"])
            select_result = db_fix.select(sql_sentence["select"])
            data[update_key] = select_result
        result = req_fix.request_all(req_method=method, req_url=url, req_mime=mime, case_data=data)

        try:
            for key in expect:
                assert expect[key] == result.json().get(key)
        except:
            print("断言失败")
            logging.error("断言失败, 模块名称为：{}，接口名称为：{}，用例标题：{}，用例为：{}，期望结果为：{}，服务器返回数据为：{}".format(module, interface, title, str(data), str(expect), result.text))
            raise AssertionError("断言失败")
        else:
            print("断言成功")


if __name__ == '__main__':
    pytest.main()